#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <unistd.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define BUFSIZE (1024*128)

void remove_crlf(char *in)
{
	int i;
	for(i = 0; in[i] != 0; i++) {
		if (in[i] == '\n' || in[i] == '\r') {
   		in[i] = ' ';
		}
	}
}

void remove_crlf2(char *in)
{
	int i;
	for(i = 0; in[i] != 0; i++) {
		if (in[i] == '\n' || in[i] == '\r') {
   		in[i] = '#';
		}
	}
}

int main(int argc, char **argv)
{
	int serv_sock;
	int clnt_sock;
	int state;
	int pid;

	FILE *fp;

	struct sockaddr_in serv_addr;
	struct sockaddr_in clnt_addr;
	int clnt_addr_size;

	char buf[BUFSIZE];
	char line[BUFSIZE];
	char response[BUFSIZE] = {0};
	char body[BUFSIZE] = {0};
	char html[BUFSIZE] = {0};

	if (argc != 2) {
		printf("Usage : %s <port>\n", argv[0]);
		exit(1);
	}

	memset(line, '0', BUFSIZE);
	state = 0;

	if ((serv_sock = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		perror("socket error : ");
		exit(0);
	}

	memset(&serv_addr, 0 , sizeof(serv_addr));
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
	serv_addr.sin_port = htons(atoi(argv[1]));

	state = bind(serv_sock , (struct sockaddr *)&serv_addr, sizeof(serv_addr));
	if (state == -1) {
		perror("bind error : ");
		exit(0);
	}
	while(1) {
   	state = listen(serv_sock, 5);
		if (state == -1) {
			perror("listen error : ");
			exit(0);
		}

		clnt_addr_size = sizeof(clnt_addr);
		clnt_sock = accept(serv_sock, (struct sockaddr *)&clnt_addr, &clnt_addr_size);
		if (clnt_sock == -1) {
			perror("Accept error : ");
			exit(0);
		}

		memset(buf, 0, BUFSIZE);
		if (read(clnt_sock, buf, BUFSIZE) <= 0) {
			 close(clnt_sock);
			 break;
		}
	    
		printf("request:\n%s\n", buf);

		char *tmp_method = strtok(buf, " ");
		printf("method : %s\n", tmp_method);
		if (strcmp(tmp_method, "GET") == 0 ) {
			strtok(NULL, "?"); 
			char *tmp_item = strtok(NULL, "=");
			char *tmp_name = strtok(NULL, " ");
		   printf("item : %s, name : %s\n", tmp_item, tmp_name);
		   if (tmp_name == NULL) {
					sprintf(html, "<html><title>Membership</title><body><form method=\"post\" action=\"\"><p>name : <input type=\"text\" name=\"name\" /></p><p><input type=\"submit\" value=\"Search\"></p></form></body></html>");
			}
		   else {
				if((fp = fopen("address.txt", "r")) == NULL) {
				  perror("file open error : ");
				  exit(0);
				}

				while(fgets(line, BUFSIZE, fp) != NULL) {
					if (strstr(line, tmp_name) != NULL || !strcmp(tmp_name, "all")) {
						  sprintf(body, "%s</br>%s", body, line);
					 }
					 memset(line, 0, BUFSIZE);
				}
				       
				remove_crlf(body);
				//printf("body[%d]\n%s", (int)strlen(body), body);
		  		sprintf(html, "<html><title>Membership</title><body>%s</body></html>", body);
				fclose(fp);
			}
		}
		else if (strcmp(tmp_method, "POST") == 0 ) {
			char *tmp_body = NULL;
			while(1) {
				char *tmp_head = strtok(NULL, "\r\n");
				if (tmp_head == NULL) {
					break;
				}
				else {
					tmp_body = tmp_head;
				} 
			}
			char *tmp_item = strtok(tmp_body, "=");
			char *tmp_name = strtok(NULL, "\r\n");
			printf("item %s, name : %s\n", tmp_item, tmp_name);
			if (tmp_name != NULL) {
				if((fp = fopen("address.txt", "r")) == NULL) {
				  perror("file open error : ");
				  exit(0);
				}

				while(fgets(line, BUFSIZE, fp) != NULL) {
					if (strstr(line, tmp_name) != NULL || !strcmp(tmp_name, "all")) {
						  sprintf(body, "%s</br>%s", body, line);
					 }
					 memset(line, 0, BUFSIZE);
				}
				       
				remove_crlf(body);
				//printf("body[%d]\n%s", (int)strlen(body), body);
		  		sprintf(html, "<html><title>Membership</title><body>%s</body></html>", body);
				fclose(fp);
			}
		}

		sprintf(response, "HTTP/1.1 200 OK\r\nContent-Length: %d\r\nContent-Type: text/html\r\n\r\n%s", (int)strlen(html), html);
		write(clnt_sock, response, strlen(response));
		memset(body, 0, BUFSIZE);
		memset(html, 0, BUFSIZE);
		memset(response, 0, BUFSIZE);
		close(clnt_sock);
	}
    
}
