#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <unistd.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define BUFSIZE (1024*8)

void remove_crlf(char *in)
{
	int i;
	for(i = 0; in[i] != 0; i++) {
		if (in[i] == '\n' || in[i] == '\r') {
   		in[i] = ' ';
		}
	}
}

int main(int argc, char **argv)
{
	int serv_sock;
	int clnt_sock;
	int state;
	int pid;

	FILE *fp;

	struct sockaddr_in serv_addr;
	struct sockaddr_in clnt_addr;
	int clnt_addr_size;

	char buf[BUFSIZE];
	char line[BUFSIZE];

	if (argc != 2) {
		printf("Usage : %s <port>\n", argv[0]);
		exit(1);
	}

	memset(line, '0', 255);
	state = 0;


	if((fp = fopen("address.txt", "r")) == NULL) {
		perror("file open error : ");
		exit(0);
	}

	if ((serv_sock = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
		perror("socket error : ");
		exit(0);
	}

	memset(&serv_addr, 0 , sizeof(serv_addr));
	serv_addr.sin_family = AF_INET;
	serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
	serv_addr.sin_port = htons(atoi(argv[1]));

	state = bind(serv_sock , (struct sockaddr *)&serv_addr, sizeof(serv_addr));
	if (state == -1) {
		perror("bind error : ");
		exit(0);
	}

	state = listen(serv_sock, 5);
	if (state == -1) {
		perror("listen error : ");
		exit(0);
	}

	clnt_addr_size = sizeof(clnt_addr);

	while(1) {
		clnt_sock = accept(serv_sock, (struct sockaddr *)&clnt_addr, &clnt_addr_size);
		if (clnt_sock == -1) {
			perror("Accept error : ");
			exit(0);
		}
		
		while(1) {
			rewind(fp);
			memset(buf, 0, BUFSIZE);
			if (read(clnt_sock, buf, BUFSIZE) <= 0) {
 				close(clnt_sock);
 				break;
			}

			printf("request: %s\n", buf);
			strtok(buf, "=");  // Lee?     // " " 공백 문자를 기준으로 문자열을 자름, 포인터 반환
			char *tmp_name = strtok(NULL, "\n"); // GA?

			remove_crlf(tmp_name);

			printf("parse: name=%s(%d)\n", tmp_name, (int)strlen(tmp_name));
			if (strncmp(buf, "quit",4) == 0) {
 				write(clnt_sock, "bye bye", 8);
 				close(clnt_sock);
 				break;
			}

			while(fgets(line, BUFSIZE, fp) != NULL) {
 				if (strstr(line, tmp_name) != NULL || !strcmp(tmp_name, "all")) {
     				write(clnt_sock, line, BUFSIZE);
 				}
 				memset(line, 0, BUFSIZE);
			}
			
			write(clnt_sock, "end", 3);
			printf("send end\n");
		}
	}
	close(clnt_sock);
}

